#!/usr/bin/perl

#-----------------------------------------------------------------------------
# Generates the listing of postings in the given NewsGroup.
# Input parameter : 
#	NG = NewsGroup name
#	Pg = Page number ( every page contains $NO_ARTICLES_INPAGE postings )
#	FG = Flag
#

require "NNTP_func.ph";

use CGI;


my $query = new CGI;

print $query->header(-type => 'text/html');
print $query->start_html(-title =>"aNews");

print $query->start_html(-bgcolor =>"white");

$ng_name = $query->param("NG");

$page_no = $query->param("Pg");

my $totalPostings = &Get_Count_NewsGrp_Postings( $ng_name );


if ( $page_no == 0 ) {
	$page_no = 1;
}

$flag =  $query->param("FG");

if ( ! $flag ) {
	$page_no = 0;
	$flag="n";
}


my $max_pages = ($totalPostings/$NO_ARTICLES_INPAGE)+1;


#
# Checking for the flag to get the user option. 
#
					# When user selects for next page
if ( $flag eq "n")
{
	if ( int($page_no) < int($max_pages) )
	{
		$page_no++;
	}
}
# When user selects for previous page
elsif ( $flag eq "p" )
{
	if ($page_no ne "1")
	{
		$page_no--;
	}
}
# When user selects see all messages
elsif ( $flag eq "a" )
{
	$page_no = 1;
	$max_pages=1;
	$NO_ARTICLES_INPAGE=$totalPostings;
}
else
{
}	

my @NewsGrp_Data = &Get_NewsGrp_Postings($ng_name, $NO_ARTICLES_INPAGE*($page_no - 1),$NO_ARTICLES_INPAGE);

# Generates HTML
print "<TABLE WIDTH=100%>\n<TR><TD ALIGN=LEFT><IMG SRC=anews.gif ALT=aNews WIDTH=200 HEIGHT=75></TD>\n<TD ALIGN=RIGHT>$MED_FONT<b>Postings in News Group : $ng_name <BR>Page $page_no of ".int($max_pages)." <BR>Total Articles : ". $totalPostings ." </b></font></TD></TR></TABLE>\n<hr noshade>";

print '<br>';
&generateOptions();
print '<br>';
&generateTable(@NewsGrp_Data);
&generateOptions();

print $query->end_html();

#-----------------------------------------------------------------------------

sub generateOptions
{

    print "<TABLE WIDTH=100% ALIGN=CENTER>\n<TR>\n";

	# If this is the not the last page
	if ( int($page_no) < int($max_pages) && $flag ne "a" ) {
        	printf ("<TD BGCOLOR=blue align=CENTER> <a href=ListPosting.cgi\?NG=$ng_name\&Pg=$page_no\&FG=n>$HEADER_FONT Next Page</FONT></a>");
	}
	else {
        	printf ("<TD BGCOLOR=#7093DB align=CENTER>$HEADER_FONT Next Page</FONT>");
	}

	# If this page is the 1st one
	if ( int($page_no) <= 1 || $flag eq "a" ) {
        	printf ("<TD BGCOLOR=#7093DB align=CENTER> $HEADER_FONT Prev Page </FONT>");
	}
	else {
        	printf ("<TD BGCOLOR=blue align=CENTER> <a href=ListPosting.cgi\?NG=$ng_name\&Pg=$page_no\&FG=p>$HEADER_FONT Prev Page </a>");
	}

        printf ("<TD BGCOLOR=blue align=CENTER> <a href=ListPosting.cgi\?NG=$ng_name\&Pg=$page_no\&FG=a>$HEADER_FONT Show All </a>");
        printf ("<TD BGCOLOR=blue align=CENTER> <a href='Javascript:win = window.open(\"PostNew.cgi\?NG=$ng_name\",\"Post\",\"width=600,height=500\");history.go(\"-1\")'>$HEADER_FONT Post New </a>");
        printf ("<TD BGCOLOR=blue align=CENTER> <a href=news.html>$HEADER_FONT Newsgroups </a>");
        printf ("<TD BGCOLOR=blue align=CENTER> <a href=anewsGrp.cgi>$HEADER_FONT Subscribe </a>");

        print ' </TR></TABLE>';


}

#-----------------------------------------------------------------------------


sub generateTable
{
        my (@allData) = @_;

        print qq { <TABLE cols=4 cellpadding="0" cellspacing="0" width="100%">
                <tr>
			<td align=center width=5% bgcolor=$COLOR_HEADERS_BG><font color="#FFFFFF">$MED_FONT <strong>Sr No.</strong></font></td>
			<td align=center width=$DATE_WIDTH bgcolor=$COLOR_HEADERS_BG><font color="#FFFFFF">$MED_FONT<strong>&nbsp;Date&nbsp;</strong></font></td>
			<td align=center width=$NAME_WIDTH bgcolor=$COLOR_HEADERS_BG><font color="#FFFFFF">$MED_FONT<strong>&nbsp;Author&nbsp;</strong></font></td>
			<td align=center width=$SUBJ_WIDTH bgcolor=$COLOR_HEADERS_BG><font color="#FFFFFF">$MED_FONT<strong>&nbsp;Subject&nbsp;</strong></font></td>
                </tr>};

        for ( my $i=0; $i< $NO_ARTICLES_INPAGE && $i < $#allData/4; $i++ )
        {

		my $tmpData;
		my $HTML="";

		# printing Date
		$tmpData = &print_Date($allData[4*$i]);

		my $srNumber = 1+$i+ ( $page_no -1 )*$NO_ARTICLES_INPAGE ;
		$HTML .= "\n<tr><td width=5% valign=top align=right>$SMALL_FONT <STRONG>$srNumber.&nbsp&nbsp";
        $HTML .= "\n<td width=$DATE_WIDTH valign=top align=left>$tmpData</td>";

						# printing Sender's Name
        $tmpData = &print_Sender($allData[4*$i+1]);

        $HTML .= "<td width=$NAME_WIDTH valign=top >$tmpData</td>";

						# printing Subject
        $tmpData = &print_Subject($allData[4*$i+2]);

		$msgId = $allData[4*$i+3];

        $HTML .= "<td width=$SUBJ_WIDTH valign=top>";              
		$HTML .= qq {<A HREF='JavaScript:win = document.open(\"PrintPosting.cgi\?NG=$ng_name\&MSGID=$msgId \", \"Test\",\"width=600,height=500,scrollbars=yes\");history.go(\"-1\")'><IMG SRC=arrow.gif ALT=\"Open this article in a new window\" ALIGN=CENTER></A><a href=PrintPosting.cgi\?NG=$ng_name\&MSGID=$msgId>};
        $HTML .= $tmpData;
		$HTML .=("</a>");
        $HTML .= '</td></tr>';
		print $HTML;
        }

	print qq { <tr>
		<td align=center width=5% bgcolor=$COLOR_HEADERS_BG>&nbsp</td>
		<td align=center width=$DATE_WIDTH bgcolor=$COLOR_HEADERS_BG>&nbsp;</td>
		<td align=center width=$NAME_WIDTH bgcolor=$COLOR_HEADERS_BG>&nbsp;</td>
		<td align=center width=$SUBJ_WIDTH bgcolor=$COLOR_HEADERS_BG>&nbsp;</td>
		</tr>};

        print '</TABLE>';
return;
}

#-------------------------------------------------------------------------

sub print_Subject
{
        my ($data) = @_;

        my @field_arr = split(/:/,$data);
        shift @field_arr;
	$processed_data = "";
        for (my $i=0;$i <=$#field_arr;$i++)
        {
                $processed_data = $processed_data.$field_arr[$i];
                $processed_data = $processed_data.":";
        }
        chop $processed_data;

        return ($SMALL_FONT.$processed_data);
}

#-------------------------------------------------------------------------
sub print_Sender
{
        my ($data) = @_;

        my @field_arr = split(/:/,$data);
        shift @field_arr;
		$processed_data = "";
        for (my $i=0;$i <=$#field_arr;$i++)
        {
                $processed_data = $processed_data.$field_arr[$i];
                $processed_data = $processed_data.":";
        }
        chop $processed_data;

		$processed_data =~ s/"//g;
		$processed_data =~ s/\(//g;
		$processed_data =~ s/\)//g;
		$processed_data =~ s/<//g;
		$processed_data =~ s/>//g;

        @field_arr = split(/ /,$processed_data);

		my $email,$name;

		$name="";

        for (my $i=0;$i <=$#field_arr;$i++) {
			# If it contains @ it should be the email address
			if ( $field_arr[$i] =~ "@" ) {
				$email = $field_arr[$i];
			}
			else {
				$name .= $field_arr[$i]." ";
			}
		}
	
        chop $processed_data;

        return ("<A HREF=mailto:$email>".$SMALL_FONT.$name."</A>");
#        return ($SMALL_FONT.$name);
}

#-------------------------------------------------------------------------

sub find_emailID
{
        my ($data) = @_;
        my @field_arr = split(/<>/,$data);
        shift @field_arr;

		return ( "HAHA".$data );	
}

#-------------------------------------------------------------------------



sub print_Date
{
   my ($data) = @_;

    my @field_arr = split(" ",$data);
	shift @field_arr;
	pop @field_arr;
	pop @field_arr;
	#pop @field_arr;

	$processed_data = "";

        for (my $i=0;$i<=$#field_arr;$i++)
        {
                $processed_data = $processed_data.$field_arr[$i]." ";
        }
	chop $processed_data;

        return ($SMALL_FONT.$processed_data);
}

#-------------------------------------------------------------------------
