require "aNewsConf.ph";

$NEWS_SERVER=$NEWS_SERVER_NAME.":".$NEWS_SERVER_PORT;


#-----------------------------------------------------------------------------
# Gets the list of all active NewsGroups.

sub List_NewsGrps
{
use Net::NNTP;
	my $key;
	my $i;
	my $j;

	my $nntp = Net::NNTP->new( $NEWS_SERVER );


	foreach $j ( @NEWSG_PATTERNS ) {
 		my $temp = $nntp->newsgroups( $j );

		foreach $key ( keys(%$temp) )
		{
			$List_Array[$i++] = $key;
		}
	}

$nntp->quit;
return @List_Array;
}

#-----------------------------------------------------------------------------
# Gets the number of postings for a particular NewGroup.

sub Get_Count_NewsGrp_Postings
{
	use Net::NNTP;

	my ($news_grp) = @_;
	my $nntp = Net::NNTP->new( $NEWS_SERVER );
	my @grpInfo = $nntp->group($news_grp);
	if ($#grpInfo == -1 )
	{
		print "Please Enter Valid News Group name !!\n";
		exit();
	}
	$nntp->quit;
	return $grpInfo[0];
}


#-----------------------------------------------------------------------------
# Gets all the postings for a particular NewGroup.

sub Get_NewsGrp_Postings
{
use Net::NNTP;

	my ($news_grp,$start,$numArt) = @_;
	#print "Start = $start Num = $numArt";

	my $nntp = Net::NNTP->new( $NEWS_SERVER );
	my @grpInfo = $nntp->group($news_grp);
	
	if ($#grpInfo == -1 )
	{
		print "Please Enter Valid News Group name !!\n";
		exit();
	}

	#print "Group Infp = @grpInfo";

	my $i=0;
	for (my $count=$grpInfo[2]-$start;$count>=$grpInfo[1];$count--)
	{
		#print "count = $count";
       	my $tmp = $nntp->head($count);
		my $data_ref =  \@$tmp;
		my $dateFound =0;
		my $fromFound =0;
		my $date,$subj,$from,$ID;
		$subj="<No Subject>";

		for (my $k=0; $k<=$#$data_ref; $k++)
		{
            if ( $$data_ref[$k] =~ "^Date:"  ) {
				$dateFound=1;
				$date = $$data_ref[$k];						
			}
            if (  $$data_ref[$k] =~ "^From:"  ) {
				$fromFound=1;
				$from = $$data_ref[$k];						
			}
            if (  $$data_ref[$k] =~ "^Subject:"  ) {
				$subj = $$data_ref[$k];						
			}
		}

		if (  $dateFound && $fromFound ) {
			$NewsGrp_Data[$j++] = $date;
			$NewsGrp_Data[$j++] = $from;
			$NewsGrp_Data[$j++] = $subj;
			$NewsGrp_Data[$j++] = $count;


			$i++;

			if ( $i > $numArt ) {
				last;
			}
		}
		else {
			#print "Invalid ID : $count";
		}
	}
	
$nntp->quit;
				# Returns an array of reference to an array
				# containing the NewsGrp Article's info.
return @NewsGrp_Data;

}

#-----------------------------------------------------------------------------
# Gets the full header and body of a particular message with specified msgID 
# and NewsGroup name.

sub Get_Posting
{
use Net::NNTP;

	my ($msgID, $newsGrp) = @_;

	my $nntp = Net::NNTP->new( $NEWS_SERVER );

	my @grpInfo = $nntp->group($newsGrp);

	if ($#grpInfo == -1 )
        {
                print "Please Enter Valid News Group name !!\n";
                exit();
        }

	$ref = $nntp->article($msgID);

	$nntp->quit;

return $ref;
}

#-----------------------------------------------------------------------------
# Checks whether the passed msgId is a valid message ID in the News Groups
# postings. If yes, returns 1, else -1.

sub CheckMsgId
{
use Net::NNTP;

	my ($msgID, $newsGrp) = @_;

	my $nntp = Net::NNTP->new( $NEWS_SERVER );

	my @grpInfo = $nntp->group($newsGrp);

	if ($#grpInfo == -1 )
	{
	      print "Please Enter Valid News Group name !!\n";
	      return -1;
	}

	if (( int($msgID) < $grpInfo[1] ) || ( int($msgID) > $grpInfo[2] ))
	{
		return 0;
	}
	else 
	{
		return 1;
	}

}

#-----------------------------------------------------------------------------

sub GetNewsGrpInfo
{
use Net::NNTP;

        my ( $newsGrp) = @_;

        my $nntp = Net::NNTP->new( $NEWS_SERVER );

        @grpInfo = $nntp->group($newsGrp);

        if ($#grpInfo == -1 )
        {
              #print "Please Enter Valid News Group name !!\n";
              return -1;
        }
	else
	{
	      return @grpInfo;
	}
} 

#-----------------------------------------------------------------------------

sub PostNew
{
    my $nntp = Net::NNTP->new( $NEWS_SERVER );

    my $newsgrpName =  $query->param("Newsgrp");
    my $NEWGRP = "Newsgroups: ${newsgrpName}";

    my $sender = $query->param("From");
    my $emailId = $query->param("EmailID");
    my $From = "From: ${sender} <${emailId}>";
    my $References = $query->param("References");
    my $Refe = "References: ${References}";

    my $topic = $query->param("Subject");
    my $Subject = "Subject: $topic";

    my $Body = $query->param("Msgbody");
	$Body =~ s/\r//g;	

    if ($nntp->postok())
    {
       $Ret = $nntp->post("$From\n$NEWGRP\n$Subject\n$Refe\n\n$Body");
       $msg = $nntp->message();
    }
    else
    {
       print "Can't Post\n\n";
    }
    $nntp->quit;
}

#-----------------------------------------------------------------------------

sub parseMsgdata
{
    $msgId = $query->param("PREVMSG");
    my $nntp = Net::NNTP->new( $NEWS_SERVER );
    my @grpInfo = $nntp->group($newsgrp);
    if ($#grpInfo == -1 )
    {
        print "Please Enter Valid News Group name !!\n";
        exit();
    }

    $head = $nntp->head($msgId);
    $body = $nntp->body($msgId);

    @msgB = @$body;
    @msgH = @$head;

    @list = ("From", "Subject", "Newsgroups", "Date", "References");
    foreach $line (@msgH)
    {
        foreach $tag (@list)
        {
           if ($line =~ /^$tag/)
           {
               ($junk,${$tag}) = split(/$tag:/, $line);
           }
        }
    }
    foreach $line (@msgH)
    {
	if ($line =~ /^Message/)
	{
	   ($junk, $Message) = split(/:/, $line);
	}
    }

    $sub = "Re:".$Subject; #for reply window
    $Orig_msg = "\n\n\n------Original Message------\n";
    $msg = $Orig_msg."From:"."$From"."Subject:"."$Subject"."Newsgroups:"."$Newsgroups"."Date:"."$Date"."\n\n"."@msgB";
}

1;	# Just to keep Perl happy

#-----------------------------------------------------------------------------
